diff --git a/src/util-mpm-b2g-cuda.h b/src/util-mpm-b2g-cuda.h
index 0d832f3..c04322c 100644
--- a/src/util-mpm-b2g-cuda.h
+++ b/src/util-mpm-b2g-cuda.h
@@ -156,5 +156,326 @@ void B2gCudaKillDispatcherThreadAPC(void);
 void B2gCudaPushPacketTo_tv_CMB2_RC(Packet *);
 void B2gCudaPushPacketTo_tv_CMB2_APC(Packet *);
 
+/** ---- Inline functions ---- */
+
+static inline uint32_t B2gCudaScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
+                                PatternMatcherQueue *, uint8_t *buf,
+                                uint16_t buflen);
+static inline uint32_t B2gCudaSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
+                                  PatternMatcherQueue *, uint8_t *buf,
+                                  uint16_t buflen);
+
+static inline void B2gCudaEndMatchAppend(MpmCtx *mpm_ctx, B2gCudaPattern *p,
+                                         uint16_t offset, uint16_t depth,
+                                         uint32_t pid, uint32_t sid,
+                                         uint8_t nosearch)
+{
+    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
+    if (em == NULL) {
+        SCLogDebug("ERROR: B2gAllocEndMatch failed");
+        return;
+    }
+
+    SCLogDebug("em alloced at %p", em);
+
+    em->id = pid;
+    em->sig_id = sid;
+    em->depth = depth;
+    em->offset = offset;
+
+    if (nosearch)
+        em->flags |= MPM_ENDMATCH_NOSEARCH;
+
+    if (p->em == NULL) {
+        p->em = em;
+        SCLogDebug("m %p m->sig_id %"PRIu32"", em, em->sig_id);
+        return;
+    }
+
+    MpmEndMatch *m = p->em;
+    while (m->next)
+        m = m->next;
+    m->next = em;
+
+    m = p->em;
+    SCLogDebug("m %p m->sig_id %" PRIu32, m, m->sig_id);
+    while (m->next) {
+        m = m->next;
+        SCLogDebug("m %p m->sig_id %" PRIu32, m, m->sig_id);
+    }
+
+    return;
+}
+
+static inline B2gCudaPattern *B2gCudaAllocPattern(MpmCtx *mpm_ctx)
+{
+    B2gCudaPattern *p = SCMalloc(sizeof(B2gCudaPattern));
+    if (p == NULL) {
+        printf("ERROR: B2gAllocPattern: malloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(p, 0, sizeof(B2gCudaPattern));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(B2gCudaPattern);
+
+    return p;
+}
+
+static inline B2gCudaHashItem *B2gCudaAllocHashItem(MpmCtx *mpm_ctx)
+{
+    B2gCudaHashItem *hi = SCMalloc(sizeof(B2gCudaHashItem));
+    if (hi == NULL) {
+        printf("ERROR: B2gCudaAllocHashItem: malloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(hi, 0, sizeof(B2gCudaHashItem));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(B2gCudaHashItem);
+
+    return hi;
+}
+
+static inline uint32_t B2gCudaInitHash(B2gCudaPattern *p)
+{
+    uint32_t hash = p->len * p->cs[0];
+    if (p->len > 1)
+        hash += p->cs[1];
+
+    return (hash % INIT_HASH_SIZE);
+}
+
+static inline uint32_t B2gCudaInitHashRaw(uint8_t *pat, uint16_t patlen)
+{
+    uint32_t hash = patlen * pat[0];
+    if (patlen > 1)
+        hash += pat[1];
+
+    return (hash % INIT_HASH_SIZE);
+}
+
+static inline int B2gCudaInitHashAdd(B2gCudaCtx *ctx, B2gCudaPattern *p)
+{
+    uint32_t hash = B2gCudaInitHash(p);
+
+    if (ctx->init_hash[hash] == NULL) {
+        ctx->init_hash[hash] = p;
+        return 0;
+    }
+
+    B2gCudaPattern *tt = NULL;
+    B2gCudaPattern *t = ctx->init_hash[hash];
+
+    /* get the list tail */
+    do {
+        tt = t;
+        t = t->next;
+    } while (t != NULL);
+
+    tt->next = p;
+
+    return 0;
+}
+
+static inline int B2gCudaCmpPattern(B2gCudaPattern *p, uint8_t *pat,
+                                    uint16_t patlen, char nocase);
+
+static inline B2gCudaPattern *B2gCudaInitHashLookup(B2gCudaCtx *ctx, uint8_t *pat,
+                                                    uint16_t patlen, char nocase)
+{
+    uint32_t hash = B2gCudaInitHashRaw(pat, patlen);
+
+    if (ctx->init_hash[hash] == NULL)
+        return NULL;
+
+    B2gCudaPattern *t = ctx->init_hash[hash];
+    for ( ; t != NULL; t = t->next) {
+        if (B2gCudaCmpPattern(t, pat, patlen, nocase) == 1)
+            return t;
+    }
+
+    return NULL;
+}
+
+static inline int B2gCudaCmpPattern(B2gCudaPattern *p, uint8_t *pat,
+                                    uint16_t patlen, char nocase)
+{
+    if (p->len != patlen)
+        return 0;
+
+    if (!((nocase && p->flags & B2G_CUDA_NOCASE) ||
+          (!nocase && !(p->flags & B2G_CUDA_NOCASE)))) {
+        return 0;
+    }
+
+    if (memcmp(p->cs, pat, patlen) != 0)
+        return 0;
+
+    return 1;
+}
+
+static inline int B2gCudaAddPattern(MpmCtx *mpm_ctx, uint8_t *pat,
+                                    uint16_t patlen, uint16_t offset,
+                                    uint16_t depth, char nocase, char scan,
+                                    uint32_t pid, uint32_t sid,
+                                    uint8_t nosearch)
+{
+    B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
+
+    SCLogDebug("ctx %p len %"PRIu16" pid %" PRIu32 ", nocase %s",
+               ctx, patlen, pid, nocase ? "true" : "false");
+
+    if (patlen == 0)
+        return 0;
+
+    /* get a memory piece */
+    B2gCudaPattern *p = B2gCudaInitHashLookup(ctx, pat, patlen, nocase);
+    if (p == NULL) {
+        SCLogDebug("allocing new pattern");
+
+        p = B2gCudaAllocPattern(mpm_ctx);
+        if (p == NULL)
+            goto error;
+
+        p->len = patlen;
+
+        if (nocase)
+            p->flags |= B2G_CUDA_NOCASE;
+
+        /* setup the case insensitive part of the pattern */
+        p->ci = SCMalloc(patlen);
+        if (p->ci == NULL)
+            goto error;
+        mpm_ctx->memory_cnt++;
+        mpm_ctx->memory_size += patlen;
+        memcpy_tolower(p->ci, pat, patlen);
+
+        /* setup the case sensitive part of the pattern */
+        if (p->flags & B2G_CUDA_NOCASE) {
+            /* nocase means no difference between cs and ci */
+            p->cs = p->ci;
+        } else {
+            if (memcmp(p->ci,pat,p->len) == 0) {
+                /* no diff between cs and ci: pat is lowercase */
+                p->cs = p->ci;
+            } else {
+                p->cs = SCMalloc(patlen);
+                if (p->cs == NULL)
+                    goto error;
+                mpm_ctx->memory_cnt++;
+                mpm_ctx->memory_size += patlen;
+                memcpy(p->cs, pat, patlen);
+            }
+        }
+
+        /* put in the pattern hash */
+        B2gCudaInitHashAdd(ctx, p);
+
+        if (mpm_ctx->pattern_cnt == 65535) {
+            printf("Max search words reached\n");
+            exit(1);
+        }
+        if (scan)
+            mpm_ctx->scan_pattern_cnt++;
+        mpm_ctx->pattern_cnt++;
+
+        if (scan) { /* SCAN */
+            if (mpm_ctx->scan_maxlen < patlen)
+                mpm_ctx->scan_maxlen = patlen;
+
+            if (mpm_ctx->scan_minlen == 0)
+                mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen)
+                mpm_ctx->scan_minlen = patlen;
+
+            p->flags |= B2G_CUDA_SCAN;
+        } else { /* SEARCH */
+            if (mpm_ctx->search_maxlen < patlen)
+                mpm_ctx->search_maxlen = patlen;
+
+            if (mpm_ctx->search_minlen == 0)
+                mpm_ctx->search_minlen = patlen;
+            else if (mpm_ctx->search_minlen > patlen)
+                mpm_ctx->search_minlen = patlen;
+        }
+    } else {
+        /* if we're reusing a pattern, check we need to check that it is a
+         * scan pattern if that is what we're adding. If so we set the pattern
+         * to be a scan pattern. */
+        if (scan) {
+            p->flags |= B2G_CUDA_SCAN;
+
+            if (mpm_ctx->scan_maxlen < patlen)
+                mpm_ctx->scan_maxlen = patlen;
+
+            if (mpm_ctx->scan_minlen == 0)
+                mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen)
+                mpm_ctx->scan_minlen = patlen;
+        }
+    }
+
+    /* we need a match */
+    B2gCudaEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
+
+    mpm_ctx->total_pattern_cnt++;
+
+    return 0;
+
+error:
+    B2gCudaFreePattern(mpm_ctx, p);
+    return -1;
+}
+
+static inline uint32_t B2gCudaBloomHash(void *data, uint16_t datalen, uint8_t iter,
+                                        uint32_t hash_size)
+{
+     uint8_t *d = (uint8_t *)data;
+     uint16_t i;
+     uint32_t hash = (uint32_t)u8_tolower(*d);
+
+     for (i = 1; i < datalen; i++) {
+         d++;
+         hash += (u8_tolower(*d)) ^ i;
+     }
+     hash <<= (iter+1);
+     hash %= hash_size;
+
+     return hash;
+}
+
+static inline int memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n)
+{
+    size_t i;
+
+    /* check backwards because we already tested the first
+     * 2 to 4 chars. This way we are more likely to detect
+     * a miss and thus speed up a little... */
+    for (i = n - 1; i; i--) {
+        if (u8_tolower(*(s2+i)) != s1[i])
+            return 1;
+    }
+
+    return 0;
+}
+
+static inline uint32_t B2gCudaScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
+                                PatternMatcherQueue *pmq, uint8_t *buf,
+                                uint16_t buflen)
+{
+    B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
+    return ctx ? ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
+}
+
+static inline uint32_t B2gCudaSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
+                                  PatternMatcherQueue *pmq, uint8_t *buf,
+                                  uint16_t buflen)
+{
+    B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
+    return ctx ? ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
+}
+
+
 #endif /* __SC_CUDA_SUPPORT__ */
 #endif /* __UTIL_MPM_B2G_CUDA_H__ */
diff --git a/src/util-mpm-b2g.c b/src/util-mpm-b2g.c
index d551535..da9f1d1 100644
--- a/src/util-mpm-b2g.c
+++ b/src/util-mpm-b2g.c
@@ -48,8 +48,6 @@ int B2gAddScanPatternCS(MpmCtx *, uint8_t *, uint16_t, uint16_t, uint16_t, uint3
 int B2gAddPatternCI(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid);
 int B2gAddPatternCS(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid);
 int B2gPreparePatterns(MpmCtx *mpm_ctx);
-inline uint32_t B2gScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
-inline uint32_t B2gSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
 uint32_t B2gScan1(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
 #ifdef B2G_SCAN2
 uint32_t B2gScan2(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
@@ -83,51 +81,6 @@ void MpmB2gRegister (void) {
     mpm_table[MPM_B2G].RegisterUnittests = B2gRegisterTests;
 }
 
-/* append an endmatch to a pattern
- *
- * Only used in the initialization phase */
-static inline void B2gEndMatchAppend(MpmCtx *mpm_ctx, B2gPattern *p,
-    uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid,
-    uint8_t nosearch)
-{
-    SCLogDebug("pid %"PRIu32", sid %"PRIu32"", pid, sid);
-
-    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
-    if (em == NULL) {
-        printf("ERROR: B2gAllocEndMatch failed\n");
-        return;
-    }
-
-    SCLogDebug("em alloced at %p", em);
-
-    em->id = pid;
-    em->sig_id = sid;
-    em->depth = depth;
-    em->offset = offset;
-
-    if (nosearch)
-        em->flags |= MPM_ENDMATCH_NOSEARCH;
-
-    if (p->em == NULL) {
-        p->em = em;
-        SCLogDebug("m %p m->sig_id %"PRIu32"", em, em->sig_id);
-        return;
-    }
-
-    MpmEndMatch *m = p->em;
-    while (m->next) {
-        m = m->next;
-    }
-    m->next = em;
-
-    m = p->em;
-    SCLogDebug("m %p m->sig_id %"PRIu32"", m, m->sig_id);
-    while (m->next) {
-        m = m->next;
-        SCLogDebug("m %p m->sig_id %"PRIu32"", m, m->sig_id);
-    }
-}
-
 #ifdef PRINTMATCH
 static void prt (uint8_t *buf, uint16_t buflen) {
     uint16_t i;
@@ -160,33 +113,6 @@ void B2gPrintInfo(MpmCtx *mpm_ctx) {
     printf("\n");
 }
 
-static inline B2gPattern *B2gAllocPattern(MpmCtx *mpm_ctx) {
-    B2gPattern *p = SCMalloc(sizeof(B2gPattern));
-    if (p == NULL) {
-        printf("ERROR: B2gAllocPattern: SCMalloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(p,0,sizeof(B2gPattern));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(B2gPattern);
-    return p;
-}
-
-static inline B2gHashItem *
-B2gAllocHashItem(MpmCtx *mpm_ctx) {
-    B2gHashItem *hi = SCMalloc(sizeof(B2gHashItem));
-    if (hi == NULL) {
-        printf("ERROR: B2gAllocHashItem: SCMalloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(hi,0,sizeof(B2gHashItem));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(B2gHashItem);
-    return hi;
-}
-
 static void B2gHashFree(MpmCtx *mpm_ctx, B2gHashItem *hi) {
     if (hi == NULL)
         return;
@@ -199,91 +125,6 @@ static void B2gHashFree(MpmCtx *mpm_ctx, B2gHashItem *hi) {
     SCFree(hi);
 }
 
-static inline void memcpy_tolower(uint8_t *d, uint8_t *s, uint16_t len) {
-    uint16_t i;
-    for (i = 0; i < len; i++) {
-        d[i] = u8_tolower(s[i]);
-    }
-}
-
-/*
- * INIT HASH START
- */
-static inline uint32_t B2gInitHash(B2gPattern *p) {
-    uint32_t hash = p->len * p->cs[0];
-    if (p->len > 1)
-        hash += p->cs[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline uint32_t B2gInitHashRaw(uint8_t *pat, uint16_t patlen) {
-    uint32_t hash = patlen * pat[0];
-    if (patlen > 1)
-        hash += pat[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline int B2gInitHashAdd(B2gCtx *ctx, B2gPattern *p) {
-    uint32_t hash = B2gInitHash(p);
-
-    //printf("B2gInitHashAdd: %" PRIu32 "\n", hash);
-
-    if (ctx->init_hash[hash] == NULL) {
-        ctx->init_hash[hash] = p;
-        //printf("B2gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-        return 0;
-    }
-
-    B2gPattern *tt = NULL;
-    B2gPattern *t = ctx->init_hash[hash];
-
-    /* get the list tail */
-    do {
-        tt = t;
-        t = t->next;
-    } while (t != NULL);
-
-    tt->next = p;
-
-    //printf("B2gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-    return 0;
-}
-
-static inline int B2gCmpPattern(B2gPattern *p, uint8_t *pat, uint16_t patlen, char nocase);
-
-static inline B2gPattern *B2gInitHashLookup(B2gCtx *ctx, uint8_t *pat, uint16_t patlen, char nocase) {
-    uint32_t hash = B2gInitHashRaw(pat,patlen);
-
-    //printf("B2gInitHashLookup: %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
-
-    if (ctx->init_hash[hash] == NULL) {
-        return NULL;
-    }
-
-    B2gPattern *t = ctx->init_hash[hash];
-    for ( ; t != NULL; t = t->next) {
-        if (B2gCmpPattern(t,pat,patlen,nocase) == 1)
-            return t;
-    }
-
-    return NULL;
-}
-
-static inline int B2gCmpPattern(B2gPattern *p, uint8_t *pat, uint16_t patlen, char nocase) {
-    if (p->len != patlen)
-        return 0;
-
-    if (!((nocase && p->flags & B2G_NOCASE) || (!nocase && !(p->flags & B2G_NOCASE))))
-        return 0;
-
-    if (memcmp(p->cs, pat, patlen) != 0)
-        return 0;
-
-    return 1;
-}
-
 /*
  * INIT HASH END
  */
@@ -312,112 +153,6 @@ void B2gFreePattern(MpmCtx *mpm_ctx, B2gPattern *p) {
     }
 }
 
-/* B2gAddPattern
- *
- * pat: ptr to the pattern
- * patlen: length of the pattern
- * nocase: nocase flag: 1 enabled, 0 disable
- * pid: pattern id
- * sid: signature id (internal id)
- */
-static inline int B2gAddPattern(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, char nocase, char scan, uint32_t pid, uint32_t sid, uint8_t nosearch) {
-    B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
-
-    SCLogDebug("ctx %p len %"PRIu16" pid %" PRIu32 ", nocase %s", ctx, patlen, pid, nocase ? "true" : "false");
-
-    if (patlen == 0)
-        return 0;
-
-    /* get a memory piece */
-    B2gPattern *p = B2gInitHashLookup(ctx, pat, patlen, nocase);
-    if (p == NULL) {
-        SCLogDebug("allocing new pattern");
-
-        p = B2gAllocPattern(mpm_ctx);
-        if (p == NULL)
-            goto error;
-
-        p->len = patlen;
-
-        if (nocase) p->flags |= B2G_NOCASE;
-
-        /* setup the case insensitive part of the pattern */
-        p->ci = SCMalloc(patlen);
-        if (p->ci == NULL) goto error;
-        mpm_ctx->memory_cnt++;
-        mpm_ctx->memory_size += patlen;
-        memcpy_tolower(p->ci, pat, patlen);
-
-        /* setup the case sensitive part of the pattern */
-        if (p->flags & B2G_NOCASE) {
-            /* nocase means no difference between cs and ci */
-            p->cs = p->ci;
-        } else {
-            if (memcmp(p->ci,pat,p->len) == 0) {
-                /* no diff between cs and ci: pat is lowercase */
-                p->cs = p->ci;
-            } else {
-                p->cs = SCMalloc(patlen);
-                if (p->cs == NULL) goto error;
-                mpm_ctx->memory_cnt++;
-                mpm_ctx->memory_size += patlen;
-                memcpy(p->cs, pat, patlen);
-            }
-        }
-
-        //printf("B2gAddPattern: ci \""); prt(p->ci,p->len);
-        //printf("\" cs \""); prt(p->cs,p->len);
-        //printf("\"\n");
-
-        /* put in the pattern hash */
-        B2gInitHashAdd(ctx, p);
-
-        if (mpm_ctx->pattern_cnt == 65535) {
-            printf("Max search words reached\n");
-            exit(1);
-        }
-        if (scan) mpm_ctx->scan_pattern_cnt++;
-        mpm_ctx->pattern_cnt++;
-
-        if (scan) { /* SCAN */
-            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
-            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
-            p->flags |= B2G_SCAN;
-        } else { /* SEARCH */
-            if (mpm_ctx->search_maxlen < patlen) mpm_ctx->search_maxlen = patlen;
-            if (mpm_ctx->search_minlen == 0) mpm_ctx->search_minlen = patlen;
-            else if (mpm_ctx->search_minlen > patlen) mpm_ctx->search_minlen = patlen;
-        }
-    } else {
-        /* if we're reusing a pattern, check we need to check that it is a
-         * scan pattern if that is what we're adding. If so we set the pattern
-         * to be a scan pattern. */
-
-        //printf("reusing B2gAddPattern: ci \""); prt(p->ci,p->len);
-        //printf("\" cs \""); prt(p->cs,p->len);
-        //printf("\"\n");
-
-        if (scan) {
-            p->flags |= B2G_SCAN;
-
-            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
-            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
-        }
-    }
-
-    /* we need a match */
-    B2gEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
-
-    mpm_ctx->total_pattern_cnt++;
-    return 0;
-
-error:
-    B2gFreePattern(mpm_ctx, p);
-    return -1;
-}
-
 int B2gAddScanPatternCI(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
     uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid, uint8_t nosearch)
 {
@@ -442,21 +177,6 @@ int B2gAddPatternCS(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
     return B2gAddPattern(mpm_ctx, pat, patlen, offset, depth, /* nocase */0, /* scan */0, pid, sid, 0);
 }
 
-static inline uint32_t B2gBloomHash(void *data, uint16_t datalen, uint8_t iter, uint32_t hash_size) {
-     uint8_t *d = (uint8_t *)data;
-     uint16_t i;
-     uint32_t hash = (uint32_t)u8_tolower(*d);
-
-     for (i = 1; i < datalen; i++) {
-         d++;
-         hash += (u8_tolower(*d)) ^ i;
-     }
-     hash <<= (iter+1);
-
-     hash %= hash_size;
-     return hash;
-}
-
 static void B2gPrepareScanHash(MpmCtx *mpm_ctx) {
     B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
     uint16_t i;
@@ -909,21 +629,6 @@ void B2gPrintSearchStats(MpmThreadCtx *mpm_thread_ctx) {
 #endif /* B2G_COUNTERS */
 }
 
-static inline int
-memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n) {
-    size_t i;
-
-    /* check backwards because we already tested the first
-     * 2 to 4 chars. This way we are more likely to detect
-     * a miss and thus speed up a little... */
-    for (i = n - 1; i; i--) {
-        if (u8_tolower(*(s2+i)) != s1[i])
-            return 1;
-    }
-
-    return 0;
-}
-
 /**
  * \brief   Function to get the user defined values for b2g algorithm from the
  *          config file 'suricata.yaml'
@@ -1195,16 +900,6 @@ void B2gThreadDestroyCtx(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx) {
     MpmMatchFreeSpares(mpm_thread_ctx, mpm_thread_ctx->qlist);
 }
 
-inline uint32_t B2gScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
-    B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
-    return ctx ? ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
-}
-
-inline uint32_t B2gSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
-    B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
-    return ctx ? ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
-}
-
 uint32_t B2gScanBNDMq(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
     B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
 #ifdef B2G_COUNTERS
diff --git a/src/util-mpm-b2g.h b/src/util-mpm-b2g.h
index c1a5520..b114482 100644
--- a/src/util-mpm-b2g.h
+++ b/src/util-mpm-b2g.h
@@ -3,6 +3,8 @@
 
 #include "util-mpm.h"
 #include "util-bloomfilter.h"
+#include "suricata-common.h"
+#include "suricata.h"
 
 #define B2G_NOCASE 0x01
 #define B2G_SCAN   0x02
@@ -23,6 +25,8 @@
 //#define B2G_WORD_SIZE 16
 //#define B2G_WORD_SIZE 8
 
+#define INIT_HASH_SIZE 65536
+
 #define B2G_HASH16(a,b) (((a)<<B2G_HASHSHIFT) | (b))
 #define B2G_Q           2
 
@@ -127,6 +131,293 @@ typedef struct B2gThreadCtx_ {
 
 void MpmB2gRegister(void);
 
+/** ----- Inline functions ----- */
+
+static inline uint32_t B2gScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
+static inline uint32_t B2gSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
+void B2gFreePattern(MpmCtx *, B2gPattern *);
+
+/* append an endmatch to a pattern
+ *
+ * Only used in the initialization phase */
+static inline void B2gEndMatchAppend(MpmCtx *mpm_ctx, B2gPattern *p,
+    uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid,
+    uint8_t nosearch)
+{
+    SCLogDebug("pid %"PRIu32", sid %"PRIu32"", pid, sid);
+
+    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
+    if (em == NULL) {
+        printf("ERROR: B2gAllocEndMatch failed\n");
+        return;
+    }
+
+    SCLogDebug("em alloced at %p", em);
+
+    em->id = pid;
+    em->sig_id = sid;
+    em->depth = depth;
+    em->offset = offset;
+
+    if (nosearch)
+        em->flags |= MPM_ENDMATCH_NOSEARCH;
+
+    if (p->em == NULL) {
+        p->em = em;
+        SCLogDebug("m %p m->sig_id %"PRIu32"", em, em->sig_id);
+        return;
+    }
+
+    MpmEndMatch *m = p->em;
+    while (m->next) {
+        m = m->next;
+    }
+    m->next = em;
+
+    m = p->em;
+    SCLogDebug("m %p m->sig_id %"PRIu32"", m, m->sig_id);
+    while (m->next) {
+        m = m->next;
+        SCLogDebug("m %p m->sig_id %"PRIu32"", m, m->sig_id);
+    }
+}
+
+static inline uint32_t B2gScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
+    B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
+    return ctx ? ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
+}
+
+static inline uint32_t B2gSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
+    B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
+    return ctx ? ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
+}
+
+static inline B2gPattern *B2gAllocPattern(MpmCtx *mpm_ctx) {
+    B2gPattern *p = SCMalloc(sizeof(B2gPattern));
+    if (p == NULL) {
+        printf("ERROR: B2gAllocPattern: SCMalloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(p,0,sizeof(B2gPattern));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(B2gPattern);
+    return p;
+}
+
+static inline B2gHashItem *
+B2gAllocHashItem(MpmCtx *mpm_ctx) {
+    B2gHashItem *hi = SCMalloc(sizeof(B2gHashItem));
+    if (hi == NULL) {
+        printf("ERROR: B2gAllocHashItem: SCMalloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(hi,0,sizeof(B2gHashItem));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(B2gHashItem);
+    return hi;
+}
+
+/*
+ * INIT HASH START
+ */
+static inline uint32_t B2gInitHash(B2gPattern *p) {
+    uint32_t hash = p->len * p->cs[0];
+    if (p->len > 1)
+        hash += p->cs[1];
+
+    return (hash % INIT_HASH_SIZE);
+}
+
+static inline uint32_t B2gInitHashRaw(uint8_t *pat, uint16_t patlen) {
+    uint32_t hash = patlen * pat[0];
+    if (patlen > 1)
+        hash += pat[1];
+
+    return (hash % INIT_HASH_SIZE);
+}
+
+static inline int B2gInitHashAdd(B2gCtx *ctx, B2gPattern *p) {
+    uint32_t hash = B2gInitHash(p);
+
+    //printf("B2gInitHashAdd: %" PRIu32 "\n", hash);
+
+    if (ctx->init_hash[hash] == NULL) {
+        ctx->init_hash[hash] = p;
+        //printf("B2gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+        return 0;
+    }
+
+    B2gPattern *tt = NULL;
+    B2gPattern *t = ctx->init_hash[hash];
+
+    /* get the list tail */
+    do {
+        tt = t;
+        t = t->next;
+    } while (t != NULL);
+
+    tt->next = p;
+
+    //printf("B2gInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+    return 0;
+}
+
+static inline int B2gCmpPattern(B2gPattern *p, uint8_t *pat, uint16_t patlen, char nocase);
+
+static inline B2gPattern *B2gInitHashLookup(B2gCtx *ctx, uint8_t *pat, uint16_t patlen, char nocase) {
+    uint32_t hash = B2gInitHashRaw(pat,patlen);
+
+    //printf("B2gInitHashLookup: %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+
+    if (ctx->init_hash[hash] == NULL) {
+        return NULL;
+    }
+
+    B2gPattern *t = ctx->init_hash[hash];
+    for ( ; t != NULL; t = t->next) {
+        if (B2gCmpPattern(t,pat,patlen,nocase) == 1)
+            return t;
+    }
+
+    return NULL;
+}
+
+static inline int B2gCmpPattern(B2gPattern *p, uint8_t *pat, uint16_t patlen, char nocase) {
+    if (p->len != patlen)
+        return 0;
+
+    if (!((nocase && p->flags & B2G_NOCASE) || (!nocase && !(p->flags & B2G_NOCASE))))
+        return 0;
+
+    if (memcmp(p->cs, pat, patlen) != 0)
+        return 0;
+
+    return 1;
+}
+
+/* B2gAddPattern
+ *
+ * pat: ptr to the pattern
+ * patlen: length of the pattern
+ * nocase: nocase flag: 1 enabled, 0 disable
+ * pid: pattern id
+ * sid: signature id (internal id)
+ */
+static inline int B2gAddPattern(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, char nocase, char scan, uint32_t pid, uint32_t sid, uint8_t nosearch) {
+    B2gCtx *ctx = (B2gCtx *)mpm_ctx->ctx;
+
+    SCLogDebug("ctx %p len %"PRIu16" pid %" PRIu32 ", nocase %s", ctx, patlen, pid, nocase ? "true" : "false");
+
+    if (patlen == 0)
+        return 0;
+
+    /* get a memory piece */
+    B2gPattern *p = B2gInitHashLookup(ctx, pat, patlen, nocase);
+    if (p == NULL) {
+        SCLogDebug("allocing new pattern");
+
+        p = B2gAllocPattern(mpm_ctx);
+        if (p == NULL)
+            goto error;
+
+        p->len = patlen;
+
+        if (nocase) p->flags |= B2G_NOCASE;
+
+        /* setup the case insensitive part of the pattern */
+        p->ci = SCMalloc(patlen);
+        if (p->ci == NULL) goto error;
+        mpm_ctx->memory_cnt++;
+        mpm_ctx->memory_size += patlen;
+        memcpy_tolower(p->ci, pat, patlen);
+
+        /* setup the case sensitive part of the pattern */
+        if (p->flags & B2G_NOCASE) {
+            /* nocase means no difference between cs and ci */
+            p->cs = p->ci;
+        } else {
+            if (memcmp(p->ci,pat,p->len) == 0) {
+                /* no diff between cs and ci: pat is lowercase */
+                p->cs = p->ci;
+            } else {
+                p->cs = SCMalloc(patlen);
+                if (p->cs == NULL) goto error;
+                mpm_ctx->memory_cnt++;
+                mpm_ctx->memory_size += patlen;
+                memcpy(p->cs, pat, patlen);
+            }
+        }
+
+        //printf("B2gAddPattern: ci \""); prt(p->ci,p->len);
+        //printf("\" cs \""); prt(p->cs,p->len);
+        //printf("\"\n");
+
+        /* put in the pattern hash */
+        B2gInitHashAdd(ctx, p);
+
+        if (mpm_ctx->pattern_cnt == 65535) {
+            printf("Max search words reached\n");
+            exit(1);
+        }
+        if (scan) mpm_ctx->scan_pattern_cnt++;
+        mpm_ctx->pattern_cnt++;
+
+        if (scan) { /* SCAN */
+            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
+            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
+            p->flags |= B2G_SCAN;
+        } else { /* SEARCH */
+            if (mpm_ctx->search_maxlen < patlen) mpm_ctx->search_maxlen = patlen;
+            if (mpm_ctx->search_minlen == 0) mpm_ctx->search_minlen = patlen;
+            else if (mpm_ctx->search_minlen > patlen) mpm_ctx->search_minlen = patlen;
+        }
+    } else {
+        /* if we're reusing a pattern, check we need to check that it is a
+         * scan pattern if that is what we're adding. If so we set the pattern
+         * to be a scan pattern. */
+
+        //printf("reusing B2gAddPattern: ci \""); prt(p->ci,p->len);
+        //printf("\" cs \""); prt(p->cs,p->len);
+        //printf("\"\n");
+
+        if (scan) {
+            p->flags |= B2G_SCAN;
+
+            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
+            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
+        }
+    }
+
+    /* we need a match */
+    B2gEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
+
+    mpm_ctx->total_pattern_cnt++;
+    return 0;
+
+error:
+    B2gFreePattern(mpm_ctx, p);
+    return -1;
+}
+
+static inline uint32_t B2gBloomHash(void *data, uint16_t datalen, uint8_t iter, uint32_t hash_size) {
+     uint8_t *d = (uint8_t *)data;
+     uint16_t i;
+     uint32_t hash = (uint32_t)u8_tolower(*d);
+
+     for (i = 1; i < datalen; i++) {
+         d++;
+         hash += (u8_tolower(*d)) ^ i;
+     }
+     hash <<= (iter+1);
+
+     hash %= hash_size;
+     return hash;
+}
+
 
 #endif
 
